Subject: Re: bug#64741: CUPS: fix the PATH settings for filters
From: Maxim Cournoyer <[email-masked]>
To: Emmanuel Beffara <[email-masked]>
Cc: [email-masked]
Date: Thu, 20 Jul 2023 17:28:29 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello,

Emmanuel Beffara <[email-masked]> writes:

> Hello,
>
> I would like to propose the attached patch for the `cups-filters` package. The
> point is to add the paths for `coreutils` and `sed` to the PATH setting in the
> wrapper scripts so that the filters can find them. Maybe other packages should
> be added, at least this patch fixes the issue I was facing.
>
> About my specific case: I want to use the printing service of my university,
> an instance of PaperCut. This is as simple as setting an LPD queue at the
> right address with the PPD printer driver provided by the university (a Ricoh
> IM C5500 PS in my case, if that makes any difference). After switching to Guix
> system a few months ago, this stopped working: print jobs were sent with no
> error message but they all appeared as 1 page in PaperCut and nothing actually
> came out of the printers. I finally took the time to explore the logs and it
> appears that CUPS at some point calls `foomatic-rip` and that this filter
> fails, as shown in these extracts from `/var/log/cups/error_log`:
>
> ```
> I [18/Jul/2023:16:34:10 +0200] [Job 12] Started filter
> /gnu/store/nhjpc32034v6186v37l51j0z2jq8xlkm-cups-server-bin/lib/cups/filter/foomatic-rip
> (PID 27451)
> [...]
> D [18/Jul/2023:16:34:21 +0200] [Job 12] Starting process \"renderer\"
> (generation 2)
> D [18/Jul/2023:16:34:21 +0200] [Job 12] JCL: \033%-12345X@PJL
> D [18/Jul/2023:16:34:21 +0200] [Job 12] <job data>
> D [18/Jul/2023:16:34:21 +0200] [Job 12]
> /gnu/store/rib9g2ig1xf3kclyl076w28parmncg4k-bash-minimal-5.1.16/bin/bash:
> line 5: date: command not found
> D [18/Jul/2023:16:34:21 +0200] [Job 12]
> /gnu/store/rib9g2ig1xf3kclyl076w28parmncg4k-bash-minimal-5.1.16/bin/bash:
> line 5: sed: command not found
> D [18/Jul/2023:16:34:21 +0200] [Job 12]
> /gnu/store/rib9g2ig1xf3kclyl076w28parmncg4k-bash-minimal-5.1.16/bin/bash:
> line 5: date: command not found
> D [18/Jul/2023:16:34:21 +0200] [Job 12]
> /gnu/store/rib9g2ig1xf3kclyl076w28parmncg4k-bash-minimal-5.1.16/bin/bash:
> line 5: sed: command not found
> D [18/Jul/2023:16:34:21 +0200] [Job 12]
> /gnu/store/rib9g2ig1xf3kclyl076w28parmncg4k-bash-minimal-5.1.16/bin/bash:
> line 5: cat: command not found
> D [18/Jul/2023:16:34:21 +0200] [Job 12] renderer exited with status
> 127
> D [18/Jul/2023:16:34:21 +0200] [Job 12] Process is dying with
> \"Encountered error Broken pipe during fwrite\", exit stat 1
> [...]
> D [18/Jul/2023:16:34:21 +0200] [Job 12] PID 27451
> (/gnu/store/nhjpc32034v6186v37l51j0z2jq8xlkm-cups-server-bin/lib/cups/filter/foomatic-rip)
> stopped with status 1.
> ```
>
> So `foomatic-rip` actually needs `date`, `sed` and `cat` but does not find
> them. The issue with required tools is known in Guix because the package
> definition for `cups-filters` already adds paths for `ghostscript-with-cups`
> and `grep`. The patch just adds necessary inputs for those, and it makes
> printing work for me. I don't know what other tools the filters might require
> in other situations.

That sounds reasonable.

> On a different level, I am surprised that the failure above does not lead to
> an actual user-visible error by CUPS. A corrupted job is actually sent
> silently (probably with some error messages mixed with the printing job or
> with malformed printing commands) although the filter does return an error
> code. Maybe this should be sent upstream as a CUPS bug?

That's indeed surprising.  I'd encourage you to try to reach out to
upstream with the problem, if that's feasible for you.

I've installed the change to the recently reintroduced core-updates
branch.

Bonus points next time if you write a GNU ChangeLog style commit message
to go along with it!

-- 
Thanks,
Maxim